'use strict';

const Hemera = require('nats-hemera');
const kubectlPlugin = require('../');
import { IExposePortRequest, PROTOCOL } from '@container-stack/kubectl';
import { TOPIC, KUBECTL_COMMANDS } from '../constants/index';
import * as nats from 'nats';
import 'jest';

const payload = require('./request.json');
const topic = TOPIC;
const command = KUBECTL_COMMANDS.EXPOSE;

describe('kubectl plugin test', () => {

    let client;

    afterAll(() => {
      setTimeout(() => process.exit(), 20000);
    });

    it('test loggerPlugin', () => {
      jest.setTimeout(30000);
      client = nats.connect({
        'url': process.env.NATS_URL,
        'user': process.env.NATS_USER,
        'pass': process.env.NATS_PW,
      });
      const hemera = new Hemera(client, { logLevel: 'trace', timeout: 30000 });

      hemera.use(kubectlPlugin, {payload});
        try {
              hemera.act({
                topic,
                cmd: command,
                payload,
              });
              hemera.close();
            } catch (err) {
              expect(err).toBeNull();
              console.error(err);
              client.close();
            }
  });
});
