import { KubectlApi } from '@container-stack/kubectl';
import { TOPIC, KUBECTL_COMMANDS} from './constants/index';
import { IKubectlSettings } from './interfaces/settings';

const Hp = require('hemera-plugin');

const kubectlPlugin = (hemera, options: { settings: IKubectlSettings } , done) => {

const { settings } = options;
const topic: string = TOPIC;
const command: string = KUBECTL_COMMANDS.EXPOSE;

hemera.add({
  topic,
  cmd: command ,
}, (req, cb) => {
  try {
    const kubectl = new KubectlApi();
    return kubectl.exposePort(req.payload);
  } catch (err) {
    throw new Error(err);
  }
});
};
  module.exports = Hp(kubectlPlugin, {
    hemera: '>=2.0.0-0',
    name: require('../package.json').name,
  });
